package com.zerohighdef.hush.commands;

import com.zerohighdef.hush.Hush;
import net.md_5.bungee.api.ChatColor;
import net.md_5.bungee.api.chat.BaseComponent;
import net.md_5.bungee.api.chat.ComponentBuilder;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;


public class MainCommand implements CommandExecutor {
    private final Hush plugin;

    public MainCommand(Hush plugin) {
        this.plugin = plugin;
        this.plugin.getCommand("hush").setExecutor(this);
    }

    @Override
    public boolean onCommand(CommandSender commandSender, Command command, String s, String[] args) {
        if (!commandSender.hasPermission("hush.admin")) {

            return true;
        }
        if (args.length == 0) {
            help(commandSender);
        } else {
            switch (args[0]) {
                case "help":
                    help(commandSender);
                    break;
                case "reload":
                    reload(commandSender);
                    break;
            }
        }
        return true;
    }

    public void reload(CommandSender commandSender) {
        plugin.reloadConfig();
        BaseComponent[] message = new ComponentBuilder().append("Plugin reloaded").color(ChatColor.GREEN).create();
        commandSender.spigot().sendMessage(message);
    }

    public void help(CommandSender commandSender) {
        String version = Bukkit.getPluginManager().getPlugin("MineAlert").getDescription().getVersion();
        BaseComponent[] message = new ComponentBuilder()
                .append(String.format("*** Hush v%s ***", version)).color(ChatColor.DARK_AQUA)
                .append("\n/hush help - Show this message").color(ChatColor.AQUA)
                .append("\n/hush reload - Reload the config").color(ChatColor.AQUA)
                .create();
        commandSender.spigot().sendMessage(message);
    }
}